/* cvd88 - Image File to D88 Image File Converter */
/* Image File is 2D(*.2D) 2D 320KB,BKDSK(*.HDM) 2HD 1.2MB,etc */
/* Maked by Nyanonon (nyano@areanine.gr.jp) */
/* Version 1.0 (2d2d88 ver.1.0) */
/* Version 1.1 (2d2d88 ver.1.1) */
/* Version 1.2 (2d2d88 ver.1.2) Rebuild Source */
/* Version 1.3 (2003/07/21) */

#include <stdio.h>
int main(int argc,char *argv[]) {
	int rc;
	int i,j,k;
	int d,c,h,r,n,x,y,z;
	long sz;
	char buf[0x10+1024];
	FILE *fp1,*fp2;
	if(argc!=3) {
		printf("usage: cvd88 <image-file> <D88-file>\n");
		exit(1);
	}
	fp1=fopen(argv[1],"rb");
	if(fp1==NULL) {
		printf("image file open error.\n");
		exit(1);
	}
	rc=fseek(fp1,0,SEEK_END);
	if(rc!=0) {
		printf("image file seek error.\n");
		rc=fclose(fp1);
		exit(1);
	}
	sz=ftell(fp1);
	if(sz==327680) {
		d=0x00;	/* DISK TYPE 00:2D */
		c=40;	/* TRACK */
		h=2;	/* SIDE */
		r=16;	/* SECTOR/TRACK */
		n=1;	/* SECTOR SIZE 1:256 */
	}
	else if(sz==1261568) {
		d=0x20;	/* DISK TYPE 20:2HD */
		c=77;	/* TRACK */
		h=2;	/* SIDE */
		r=8;	/* SECTOR/TRACK */
		n=3;	/* SECTOR SIZE 3:1024 */
	}
	else {
		printf("unsupported image file.\n");
		rc=fclose(fp1);
		exit(1);
	}
	rc=fseek(fp1,0,SEEK_SET);
	if(rc!=0) {
		printf("image file seek error.\n");
		rc=fclose(fp1);
		exit(1);
	}
	fp2=fopen(argv[2],"wb");
	if(fp2==NULL) {
		printf("D88 file open error.\n");
		rc=fclose(fp1);
		exit(1);
	}
	if(n==0) x=128;
	else if(n==2) x=512;
	else if(n==3) x=1024;
	else x=256;
	y=0x10+x;
	z=c*h;
	memset(buf,0x00,0x2b0);
	buf[0x1b]=d;
	sz=0x2b0+y*r*z;
	buf[0x1c]=(sz%0x10000)%0x100;
	buf[0x1d]=(sz%0x10000)/0x100;
	buf[0x1e]=(sz/0x10000)%0x100;
	buf[0x1f]=(sz/0x10000)/0x100;
	sz=0x2b0;
	for(i=0;i<z;i++) {
		buf[0x20+i*4]=(sz%0x10000)%0x100;
		buf[0x21+i*4]=(sz%0x10000)/0x100;
		buf[0x22+i*4]=(sz/0x10000)%0x100;
		buf[0x23+i*4]=(sz/0x10000)/0x100;
		sz=sz+y*r;
	}
	sz=fwrite(buf,1,0x2b0,fp2);
	if(sz!=0x2b0) {
		printf("file write error.\n");
		rc=fclose(fp2);
		rc=fclose(fp1);
		exit(1);
	}
	memset(buf,0x00,y);
	i=j=k=0;
	while(i<c) {
		buf[0x00]=i;
		buf[0x01]=j;
		buf[0x02]=k+1;
		buf[0x03]=n;
		buf[0x04]=r%0x100;
		buf[0x05]=r/0x100;
		buf[0x0e]=x%0x100;
		buf[0x0f]=x/0x100;
		sz=fread(buf+0x10,1,x,fp1);
		if(sz!=x) {
			printf("image file read error.\n");
			rc=fclose(fp2);
			rc=fclose(fp1);
			exit(1);
		}
		sz=fwrite(buf,1,y,fp2);
		if(sz!=y) {
			printf("D88 file write error.\n");
			rc=fclose(fp2);
			rc=fclose(fp1);
			exit(1);
		}
		k++;
		if(k>=r) {
			k=0;
			j++;
			if(j>=h) {
				j=0;
				i++;
			}
		}
	}
	rc=fclose(fp2);
	if(rc!=0) {
		printf("D88 file close error.\n");
		rc=fclose(fp1);
		exit(1);
	}
	rc=fclose(fp1);
	if(rc!=0) {
		printf("image file close error.\n");
		exit(1);
	}
	return(0);
}
